<?php
declare (strict_types = 1);

namespace app\admin\model;

use think\Model;

/**
 * @mixin \think\Model
 */
class CombindBninfo extends Model
{
    protected $createTime="addtime";
    
    public function AaddBNLog($spuCode='',$bnCode='',$bnArr=[]){
        if(empty($bnArr)) return ;
        $list=[];
        foreach ($bnArr as $item){
                $tmp=[];
                $tmp["bnCode"]=$bnCode;
                $tmp["spuCode"]=$spuCode;
                $tmp["child_bnCode"]=$item['bnCode'];
                $tmp["stock_id"]=$item['stockid'];
                $tmp["childCode"]=$item['spuCode'];
                $tmp["childBnNum"]=$item['num'];
                $tmp["origin_price"]=$item['origin_price'];
                $list[]=$tmp;
        }
        
        $this->saveAll($list);
    }
    /**
	* @param string $spuCode
	* @param string $bnCode
	* @param string $num
	*/
    public function  subBN($spuCode='',$bnCode='',$childCode='',$num=''){
        $stockinfo = $this->where(["spuCode"=>$spuCode,"bnCode"=>$bnCode,"childCode"=>$childCode])->where("childBnNum",">",0)->order("id desc")
        ->select()->toArray();
        if(empty($stockinfo)) throw new \Exception("未找到关联得bn库存数据");
        foreach ($stockinfo as $item){
        	$tempnum=0;
        	if($num > $item['childBnNum']){
        		$tempnum = $item['childBnNum'];
        		$num= $num -$item['childBnNum'];
        		$item['childBnNum']=0;
        	}else{
        		
        		$tempnum = $num;
        		$item['childBnNum']=$item['childBnNum'] -$num;
        		$num =0;
        	}
        	$this->save($item);
        	$up=GoodStockInfo::AddBn($item['stock_id'],$item['child_bnCode'],$tempnum,$item['origin_price']);
        	if($up==false) throw new \Exception('bn库存数据更新失败');
        	$save=  (new GoodStock())->where(["id"=>$item['stock_id']])->inc("usable_stock",$tempnum)->inc("total_stock",$tempnum)->save();
        	if($save==false) throw new \Exception('bn库存数据更新失败');
        }
       return true;
    }
}
